#ifndef MYMODEL_H
#define MYMODEL_H

#include <QObject>
#include <QtGui>
#include <QSqlQueryModel>
#include <QSqlQuery>
#include <QSqlTableModel>
#include <QMap>

class MyModel : public QSqlTableModel {
Q_OBJECT
public:
    explicit MyModel(QObject *parent = 0);
    Qt::ItemFlags flags(const QModelIndex &index) const;
    bool setData(const QModelIndex &, const QVariant &, int);
    QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const;
    void setPointers(QMap <int, QString> newPointers){pointers_map = newPointers;}
    QMap <int, QString> pointers(){return pointers_map;}
private:
    QMap <int, QString> pointers_map; //             
                                  //     -   -    

signals:

public slots:

};

#endif // MYMODEL_H
